/****************************************************************************/
/* WebWorks Help API                                                        */
/*                                                                          */
/*                                                                          */
/****************************************************************************/


#ifndef WWHELP_API_H
#define WWHELP_API_H


/* Declare exported DLL functions */
/*                                */
#ifdef WWHAPI_EXPORTS
#  if defined(_WIN32)
#    define WWHEXPORT __declspec(dllexport)
#  elif TARGET_OS_MAC
#    define WWHEXPORT
#  else
#    define WWHEXPORT
#  endif
#else
#  define WWHEXPORT
#endif


#ifdef __cplusplus
extern "C"
{
#endif

/****************************************************************************/
/* Define NULL                                                              */
/*                                                                          */
/****************************************************************************/

#ifndef NULL
#define NULL 0
#endif


/****************************************************************************/
/* WebWorks Help API functions                                              */
/*                                                                          */
/****************************************************************************/

WWHEXPORT int  WWHelp_Startup(const char* pParamBaseURL);
WWHEXPORT int  WWHelp_Shutdown();

WWHEXPORT int  WWHelp_DisplayHelp(const char* pParamContext,
                                  const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpWithNavigation(const char* pParamContext,
                                                const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpWithContents(const char* pParamContext,
                                              const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpWithIndex(const char* pParamContext,
                                           const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpWithSearch(const char* pParamContext,
                                            const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpWithFavorites(const char* pParamContext,
                                               const char* pParamTopic);
WWHEXPORT int  WWHelp_DisplayHelpNavigation();
WWHEXPORT int  WWHelp_DisplayHelpContents();
WWHEXPORT int  WWHelp_DisplayHelpIndex();
WWHEXPORT int  WWHelp_DisplayHelpSearch();
WWHEXPORT int  WWHelp_DisplayHelpFavorites();

#ifdef __cplusplus
}
#endif


#endif
