' Copyright (c) 2003 Quadralay Corporation.  All rights reserved.
'
'$Id: WWHelp4.vbs,v 1.2 2004/03/17 20:55:56 allums Exp $
'

' ###############################################

Set GlobalFileSystem = CreateObject("Scripting.FileSystemObject")
Set GlobalShell = CreateObject("WScript.Shell")

WScript.Quit(Not WWHelp4_Main)

' ###############################################

Function WWHelp4_Main()
  Dim bVarSuccess


  ' Initialize return value
  '
  bVarSuccess = False

  WScript.Echo "WebWorks Help 4.0 API: Start"

  ' Register WWHelp4 COM object
  '
  If (WWHelp4_RegisterCOMObject()) Then
    ' Invoke Help
    '
    If (WWHelp4_DisplayHelp("beta", "section2")) Then
      ' Success!
      '
      bVarSuccess = True

      WScript.Echo "WebWorks Help 4.0 API: Succeeded!"
    Else
      ' Error invoking help topic
      '
      WScript.Echo "WebWorks Help 4.0 API: Error displaying help topic."
    End If
  Else
    ' Error registering COM object
    '
    WScript.Echo "WebWorks Help 4.0 API: Unable to register WWHelp4.dll as a COM service."
  End If

  WWHelp4_Main = bVarSuccess
End Function

' ###############################################

Function WWHelp4_RegisterCOMObject()
  Dim bVarSuccess
  Dim VarWWHelp4Path
  Dim VarCommand


  ' Initialize return value
  '
  bVarSuccess = False

  ' Determine location of WWHelp4.dll
  '
  VarWWHelp4Path = WScript.ScriptFullName
  VarWWHelp4Path = GlobalFileSystem.GetParentFolderName(VarWWHelp4Path)
  VarWWHelp4Path = GlobalFileSystem.GetParentFolderName(VarWWHelp4Path)
  VarWWHelp4Path = GlobalFileSystem.GetParentFolderName(VarWWHelp4Path)
  VarWWHelp4Path = GlobalFileSystem.BuildPath(VarWWHelp4Path, "WWHelp4.dll")

  ' Register DLL as a COM object
  '
  If (GlobalFileSystem.FileExists(VarWWHelp4Path)) Then
    ' Use regsvr32
    '
    VarCommand = "regsvr32 /s """ & VarWWHelp4Path & """"
    If (GlobalShell.Run(VarCommand, 0, True) = 0) Then
      ' Success!
      '
      bVarSuccess = True
    End If
  End If

  WWHelp4_RegisterCOMObject = bVarSuccess
End Function

' ###############################################

Function WWHelp4_DisplayHelp(ParamContext, _
                             ParamTopic)
  Dim bVarSuccess
  Dim VarHelpFolderPath
  Dim VarHelpBaseURL
  Dim VarWWHelp4API


  ' Initialize return value
  '
  bVarSuccess = False

  ' Determine location of help set
  '
  VarHelpFolderPath = WScript.ScriptFullName
  VarHelpFolderPath = GlobalFileSystem.GetParentFolderName(VarHelpFolderPath)
  VarHelpFolderPath = GlobalFileSystem.GetParentFolderName(VarHelpFolderPath)
  VarHelpFolderPath = GlobalFileSystem.GetParentFolderName(VarHelpFolderPath)
  VarHelpFolderPath = GlobalFileSystem.GetParentFolderName(VarHelpFolderPath)
  VarHelpFolderPath = GlobalFileSystem.GetParentFolderName(VarHelpFolderPath)
  VarHelpFolderPath = GlobalFileSystem.BuildPath(VarHelpFolderPath, "example")
  VarHelpFolderPath = GlobalFileSystem.BuildPath(VarHelpFolderPath, "helpset")
  VarHelpBaseURL = "file:///" & WW_Strings_Replace(VarHelpFolderPath, "\", "/")

  ' Create WWHelp 4 API object
  '
  Set VarWWHelp4API = CreateObject("WWHelp4.API")

  ' Initialize WWHelp 4.0 API
  '
  If (VarWWHelp4API.Startup(VarHelpBaseURL) = 0) Then
    ' Display Help
    '
    If (VarWWHelp4API.DisplayHelp(ParamContext, ParamTopic) = 0) Then
      ' Success!
      '
      bVarSuccess = True
    End If

    ' Uninitialize WWHelp 4.0 API
    '
    Call VarWWHelp4API.Shutdown()
  Else
    ' Unable to initialize
    '
    WScript.Echo "Unable to initialize WebWorks Help 4.0 API."
  End If

  WWHelp4_DisplayHelp = bVarSuccess
End Function

' ###############################################

Function WW_Strings_Replace(ParamString, _
                            ParamPattern, _
                            ParamReplacement)
  Dim VarString
  Dim VarIndex


  ' Search for pattern
  '
  VarString = ParamString
  VarIndex = InStr(1, VarString, ParamPattern, 1)

  ' Replace pattern and advance
  '
  Do While (VarIndex > 0)
    VarString = Left(VarString, VarIndex - 1) & ParamReplacement & Mid(VarString, VarIndex + Len(ParamPattern))
    VarIndex = InStr(VarIndex + Len(ParamReplacement), VarString, ParamPattern, 1)
  Loop

  ' Return the result
  '
  WW_Strings_Replace = VarString
End Function

' ###############################################
